# == Class: firewalld
#
# Manage the firewalld service
#
# See the README.md for usage instructions for the firewalld_zone and
# firewalld_rich_rule types
#
# === Examples
#
#  include firewalld
#
# === Authors
#
# Craig Dunn <craig@craigdunn.org>
#
# === Copyright
#
# Copyright 2015 Craig Dunn
#
#
class firewalld {

    package { [ 'firewalld', 'firewall-config' ]:
      ensure => installed,
    }

    service { 'firewalld':
      ensure    => running,
      enable    => true,
      subscribe => Package['firewalld'],
    }
   
    exec { 'firewalld::reload':
      path        => '/usr/bin:/bin',
      command     => 'firewall-cmd --complete-reload',
      refreshonly => true,
   }
     
    Service['firewalld'] -> Firewalld_zone <||> ~> Exec['firewalld::reload']
    Service['firewalld'] -> Firewalld_rich_rule <||> ~> Exec['firewalld::reload']
}
